Index: issm/trunk/src/c/classes/matrix/Matrix.h
===================================================================
--- issm/trunk/src/c/classes/matrix/Matrix.h	(revision 13405)
+++ issm/trunk/src/c/classes/matrix/Matrix.h	(revision 13975)
@@ -76,4 +76,31 @@
 		}
 		/*}}}*/
+		/*FUNCTION Matrix(int m,int n,int M,int N,int* d_nnz,int* o_nnz,int type){{{*/
+		#ifdef _HAVE_PETSC_
+		Matrix(int m,int n,int M,int N,int* d_nnz,int* o_nnz,int in_type=PetscMatType){
+		#else
+		Matrix(int m,int n,int M,int N,int* d_nnz,int* o_nnz,int in_type=SeqMatType){
+		#endif
+
+			#ifdef _HAVE_PETSC_
+			pmatrix=NULL;
+			#endif
+			smatrix=NULL;
+			type=in_type;
+
+			if(type==PetscMatType){
+				#ifdef _HAVE_PETSC_
+				this->pmatrix=new PetscMat(m,n,M,N,d_nnz,o_nnz);
+				#else
+				_error_("Petsc matrix format not usable, as Petsc has not been compiled!");
+				#endif
+			}
+			else if(type==SeqMatType){
+				this->smatrix=new SeqMat<doubletype>(m,n,M,N,d_nnz,o_nnz);
+			}
+			else _error_("Matrix type: " << type << " not supported yet!");
+
+		}
+		/*}}}*/
 		/*FUNCTION Matrix(int M,int N,IssmDouble sparsity,int in_type){{{*/
 		#ifdef _HAVE_PETSC_
@@ -163,6 +190,4 @@
 				#ifdef _HAVE_PETSC_
 				delete this->pmatrix;
-				#else
-				_error_("Petsc matrix format not usable, as Petsc has not been compiled!");
 				#endif
 			}
@@ -170,5 +195,4 @@
 				delete this->smatrix;
 			}
-			else _error_("Matrix type: " << type << " not supported yet!");
 
 		}
@@ -192,4 +216,17 @@
 		}
 		/*}}}*/
+		/*FUNCTION AllocationInfo{{{*/
+		void AllocationInfo(void){
+			_assert_(this);
+			if(type==PetscMatType){
+				#ifdef _HAVE_PETSC_
+				this->pmatrix->AllocationInfo();
+				#endif
+			}
+			else if(type==SeqMatType){
+				//this->smatrix->AllocationInfo();
+			}
+			else _error_("Matrix type: " << type << " not supported yet!");
+		}/*}}}*/
 		/*FUNCTION Assemble{{{*/
 		void Assemble(void){
@@ -274,7 +311,5 @@
 		Matrix* Duplicate(void){
 
-			Matrix* output=NULL;
-
-			output=new Matrix();
+			Matrix* output=new Matrix();
 
 			if(type==PetscMatType){
@@ -306,5 +341,4 @@
 			else _error_("Matrix type: " << type << " not supported yet!");
 
-
 			return output;
 		}
Index: issm/trunk/src/c/classes/matrix/Vector.h
===================================================================
--- issm/trunk/src/c/classes/matrix/Vector.h	(revision 13405)
+++ issm/trunk/src/c/classes/matrix/Vector.h	(revision 13975)
@@ -61,5 +61,4 @@
 			type=in_type;
 
-
 			if(type==PetscVecType){
 			#ifdef _HAVE_PETSC_
@@ -71,4 +70,31 @@
 			else if(type==SeqVecType){
 				this->svector=new SeqVec<doubletype>(M,fromlocalsize);
+			}
+			else _error_("Vector type: " << type << " not supported yet!");
+
+		}
+		/*}}}*/
+		/*FUNCTION Vector(int m,int M,int in_type){{{*/
+		#ifdef _HAVE_PETSC_
+		Vector(int m,int M,int in_type=PetscVecType){
+		#else
+		Vector(int m,int M,int in_type=SeqVecType){
+		#endif
+
+			#ifdef _HAVE_PETSC_
+			pvector=NULL;
+			#endif
+			svector=NULL;
+			type=in_type;
+
+			if(type==PetscVecType){
+			#ifdef _HAVE_PETSC_
+				this->pvector=new PetscVec(m,M);
+			 #else
+				_error_("Petsc matrix format not usable, as Petsc has not been compiled!");
+			 #endif
+			}
+			else if(type==SeqVecType){
+				this->svector=new SeqVec<doubletype>(m,M);
 			}
 			else _error_("Vector type: " << type << " not supported yet!");
@@ -111,6 +137,4 @@
 				#ifdef _HAVE_PETSC_
 				delete this->pvector;
-				#else
-				_error_("Petsc matrix format not usable, as Petsc has not been compiled!");
 				#endif
 			}
@@ -118,5 +142,4 @@
 				delete this->svector;
 			}
-			else _error_("Vector type: " << type << " not supported yet!");
 		}
 		/*}}}*/
@@ -171,5 +194,4 @@
 		void SetValues(int ssize, int* list, doubletype* values, InsMode mode){
 
-
 			if(type==PetscVecType){
 				#ifdef _HAVE_PETSC_
@@ -183,6 +205,4 @@
 			}
 			else _error_("Vector type: " << type << " not supported yet!");
-
-
 
 		}
@@ -207,5 +227,4 @@
 		/*FUNCTION GetValue{{{*/
 		void GetValue(doubletype* pvalue,int dof){
-
 
 			if(type==PetscVecType){
@@ -256,5 +275,4 @@
 		void GetLocalSize(int* pM){
 
-
 			if(type==PetscVecType){
 				#ifdef _HAVE_PETSC_
@@ -276,5 +294,4 @@
 			Vector* output=NULL;
 
-
 			if(type==PetscVecType){
 				#ifdef _HAVE_PETSC_
@@ -298,5 +315,4 @@
 		void Set(doubletype value){
 
-
 			if(type==PetscVecType){
 				#ifdef _HAVE_PETSC_
@@ -316,5 +332,4 @@
 		void AXPY(Vector* X, doubletype a){
 
-
 			if(type==PetscVecType){
 				#ifdef _HAVE_PETSC_
@@ -334,5 +349,4 @@
 		void AYPX(Vector* X, doubletype a){
 
-
 			if(type==PetscVecType){
 				#ifdef _HAVE_PETSC_
@@ -346,5 +360,4 @@
 			}
 			else _error_("Vector type: " << type << " not supported yet!");
-
 
 		}
@@ -374,5 +387,4 @@
 		void Copy(Vector* to){
 
-
 			if(type==PetscVecType){
 				#ifdef _HAVE_PETSC_
@@ -386,5 +398,4 @@
 			}
 			else _error_("Vector type: " << type << " not supported yet!");
-
 
 		}
@@ -413,5 +424,4 @@
 		void Scale(doubletype scale_factor){
 
-
 			if(type==PetscVecType){
 				#ifdef _HAVE_PETSC_
@@ -451,5 +461,4 @@
 		void PointwiseDivide(Vector* x,Vector* y){
 
-
 			if(type==PetscVecType){
 				#ifdef _HAVE_PETSC_
Index: issm/trunk/src/c/classes/objects/Constraints/SpcDynamic.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Constraints/SpcDynamic.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Constraints/SpcDynamic.cpp	(revision 13975)
@@ -41,5 +41,5 @@
 }
 /*}}}*/
-		
+
 /*Object virtual functions definitions:*/
 /*FUNCTION SpcDynamic::Echo {{{*/
@@ -65,10 +65,4 @@
 /*FUNCTION SpcDynamic::Id {{{*/
 int    SpcDynamic::Id(void){ return sid; }
-/*}}}*/
-/*FUNCTION SpcDynamic::MyRank {{{*/
-int    SpcDynamic::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
 /*}}}*/
 /*FUNCTION SpcDynamic::ObjectEnum{{{*/
@@ -117,5 +111,5 @@
 /*FUNCTION SpcDynamic::GetNodeId {{{*/
 int   SpcDynamic::GetNodeId(){
-	
+
 	return nodeid;
 }
Index: issm/trunk/src/c/classes/objects/Constraints/SpcDynamic.h
===================================================================
--- issm/trunk/src/c/classes/objects/Constraints/SpcDynamic.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Constraints/SpcDynamic.h	(revision 13975)
@@ -33,5 +33,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/Constraints/SpcStatic.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Constraints/SpcStatic.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Constraints/SpcStatic.cpp	(revision 13975)
@@ -40,5 +40,5 @@
 }
 /*}}}*/
-		
+
 /*Object virtual functions definitions:*/
 /*FUNCTION SpcStatic::Echo {{{*/
@@ -68,10 +68,4 @@
 /*FUNCTION SpcStatic::Id {{{*/
 int    SpcStatic::Id(void){ return sid; }
-/*}}}*/
-/*FUNCTION SpcStatic::MyRank {{{*/
-int    SpcStatic::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
 /*}}}*/
 /*FUNCTION SpcStatic::ObjectEnum{{{*/
@@ -118,5 +112,5 @@
 /*FUNCTION SpcStatic::GetNodeId {{{*/
 int   SpcStatic::GetNodeId(){
-	
+
 	return nodeid;
 }
Index: issm/trunk/src/c/classes/objects/Constraints/SpcStatic.h
===================================================================
--- issm/trunk/src/c/classes/objects/Constraints/SpcStatic.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Constraints/SpcStatic.h	(revision 13975)
@@ -32,5 +32,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/Constraints/SpcTransient.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Constraints/SpcTransient.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Constraints/SpcTransient.cpp	(revision 13975)
@@ -54,5 +54,5 @@
 }
 /*}}}*/
-		
+
 /*Object virtual functions definitions:*/
 /*FUNCTION SpcTransient::Echo {{{*/
@@ -81,10 +81,4 @@
 int    SpcTransient::Id(void){ return sid; }
 /*}}}*/
-/*FUNCTION SpcTransient::MyRank {{{*/
-int    SpcTransient::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION SpcTransient::ObjectEnum{{{*/
 int SpcTransient::ObjectEnum(void){
@@ -103,5 +97,5 @@
 /*FUNCTION SpcTransient::InAnalysis{{{*/
 bool SpcTransient::InAnalysis(int in_analysis_type){
-	
+
 	if (in_analysis_type==this->analysis_type) return true;
 	else return false;
@@ -120,5 +114,5 @@
 	/*Chase through nodes and find the node to which this SpcTransient applys: */
 	node=(Node*)nodes->GetObjectById(NULL,nodeid);
-	
+
 	if(node){ //in case the spc is dealing with a node on another cpu
 
@@ -165,5 +159,5 @@
 /*FUNCTION SpcTransient::GetNodeId {{{*/
 int   SpcTransient::GetNodeId(){
-	
+
 	return nodeid;
 }
@@ -174,3 +168,2 @@
 }
 /*}}}*/
-
Index: issm/trunk/src/c/classes/objects/Constraints/SpcTransient.h
===================================================================
--- issm/trunk/src/c/classes/objects/Constraints/SpcTransient.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Constraints/SpcTransient.h	(revision 13975)
@@ -34,5 +34,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/Contour.h
===================================================================
--- issm/trunk/src/c/classes/objects/Contour.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Contour.h	(revision 13975)
@@ -22,18 +22,18 @@
 	public: 
 
-		int     id;
-		int	  nods;  //number of vertices in the contour
-		doubletype* x;
-		doubletype* y;
-		bool    closed; //is this contour closed?
+		int         id;
+		int         nods;     //number of vertices in the contour
+		doubletype *x;
+		doubletype *y;
+		bool        closed;   //is this contour closed?
 
 		/*Contour constructors, destructors :*/
-		/*FUNCTION Contour() default constructor {{{*/
+		/*FUNCTION Contour() {{{*/
 		Contour(){
-			this->id=0;
-			this->nods=0;
-			this->x=NULL;
-			this->y=NULL;
-			this->closed=false;
+			this->id     = 0;
+			this->nods   = 0;
+			this->x      = NULL;
+			this->y      = NULL;
+			this->closed = false;
 		}
 		/*}}}*/
@@ -41,7 +41,7 @@
 		Contour(int pid,int pnods, doubletype* px, doubletype* py,bool pclosed){
 
-			this->id=pid;
-			this->nods=pnods;
-			this->closed=pclosed;
+			this->id     = pid;
+			this->nods   = pnods;
+			this->closed = pclosed;
 			if(nods){
 				this->x=xNew<doubletype>(nods);
@@ -52,5 +52,5 @@
 		}
 		/*}}}*/
-		/*FUNCTION Contour() default constructor {{{*/
+		/*FUNCTION ~Contour() {{{*/
 		~Contour(){
 			xDelete<doubletype>(this->x);
@@ -59,18 +59,14 @@
 		/*}}}*/
 
-
 		/*Object virtual function resolutoin: */
 		/*FUNCTION Echo(){{{*/
 		void Echo(void){
-
-			int i;
-
-			_printLine_("Contour: " << id);
-			_printLine_("   nods: " << nods);
-			_printLine_("   closed: " << (closed?"true":"false"));
+			_printLine_(" Contour: " << id);
+			_printLine_("    nods: " << nods);
+			_printLine_("  closed: " << (closed?"true":"false"));
 			if(nods){
-				_printLine_("   x,y:");
-				for(i=0;i<nods;i++){
-					_printLine_(i << ": " << x[i] << "|" << y[i]);
+				_printLine_("   x , y:");
+				for(int i=0;i<nods;i++){
+					_printLine_(i << ": " << x[i] << " | " << y[i]);
 				}
 			}
@@ -87,23 +83,12 @@
 		}
 		/*}}}*/
-		/*FUNCTION MyRank{{{*/
-		int    MyRank(void){ 
-			extern int my_rank;
-
-			return my_rank; 
-		}
-		/*}}}*/
 		/*FUNCTION ObjectEnum{{{*/
 		int ObjectEnum(void){
-
 			return ContourEnum;
-
 		}
 		/*}}}*/
 		/*FUNCTION copy {{{*/
 		Object* copy() {
-
 			return new Contour(*this); 
-
 		}
 		/*}}}*/
Index: issm/trunk/src/c/classes/objects/DependentObject.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/DependentObject.cpp	(revision 13975)
+++ issm/trunk/src/c/classes/objects/DependentObject.cpp	(revision 13975)
@@ -0,0 +1,104 @@
+/*!\file DependentObject.c
+ * \brief: implementation of the DependentObject object
+ */
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "./objects.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+#include "../../shared/shared.h"
+#include "../../Container/Container.h"
+#include "../../include/include.h"
+
+/*DependentObject constructors and destructor*/
+/*FUNCTION DependentObject::DependentObject(){{{*/
+DependentObject::DependentObject(){
+	this->name=NoneEnum;
+	this->type=0;
+	this->index=-1;
+}
+/*}}}*/
+/*FUNCTION DependentObject::DependentObject(int in_name, int in_type, int in_index){{{*/
+DependentObject::DependentObject(int in_name, int in_type,int in_index){
+
+	this->name=in_name;
+	this->type=in_type;
+	this->index=in_index;
+	if(in_type!=0 && in_type!=1)_error_("cannot create an DependentObject of type " << in_type);
+	if(in_type==1)_error_("not implemented yet!");
+
+}
+/*}}}*/
+/*FUNCTION DependentObject::~DependentObject() {{{*/
+DependentObject::~DependentObject(){ //destructor
+}
+/*}}}*/
+
+/*Object virtual functions definitions:*/
+/*FUNCTION DependentObject::Echo{{{*/
+void DependentObject::Echo(void){
+
+	_printLine_("DependentObject:");
+	_printLine_("   name: " << EnumToStringx(this->name));
+	if(this->type==0)
+		_printLine_("   type: scalar");
+	else if(this->type==1)
+		_printLine_("   type: vertex");
+	else
+		_error_(" unknown type: " << this->type);
+	if(this->index>=0) _printLine_("   index: " << this->index);
+}
+/*}}}*/
+/*FUNCTION DependentObject::DeepEcho{{{*/
+void DependentObject::DeepEcho(void){
+	this->Echo();
+}
+/*}}}*/
+/*FUNCTION DependentObject::Id{{{*/
+int    DependentObject::Id(void){ return -1; }
+/*}}}*/
+/*FUNCTION DependentObject::ObjectEnum{{{*/
+int DependentObject::ObjectEnum(void){
+
+	return DependentObjectEnum;
+
+}
+/*}}}*/
+/*FUNCTION DependentObject::copy{{{*/
+Object* DependentObject::copy(void) { 
+	return new DependentObject(name,type,index);
+} /*}}}*/
+
+/*DependentObject methods: */
+/*FUNCTION DependentObject::NumDependents{{{*/
+int  DependentObject::NumDependents(void){
+
+	/*Branch according to the type of variable: */
+	if(type==0){ /*scalar:*/
+		return 1;
+	}
+	else if(type==1){ /* vector:*/
+		_error_("not implemented yet!");
+	}
+	else _error_("should not have a type of " << type);
+}
+/*}}}*/
+/*FUNCTION DependentObject::Responsex{{{*/
+void  DependentObject::Responsex(IssmDouble* poutput_value,FemModel* femmodel){
+
+	if(this->name==MassFluxEnum){
+
+		/*to identify the mass flux that will be computed, we need the index of the profile: */
+		femmodel->parameters->SetParam(this->index,IndexEnum);
+	}
+
+	femmodel->Responsex(poutput_value,this->name,false,0);
+
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/objects/DependentObject.h
===================================================================
--- issm/trunk/src/c/classes/objects/DependentObject.h	(revision 13975)
+++ issm/trunk/src/c/classes/objects/DependentObject.h	(revision 13975)
@@ -0,0 +1,47 @@
+/*!\file: DependentObject.h
+ * \brief prototype for DependentObject.h
+ */ 
+
+#ifndef _DEPENDENTOBJECT_H_
+#define  _DEPENDENTOBJECT_H_
+
+/*{{{*/
+#include "./Object.h"
+#include "../../shared/shared.h"
+/*}}}*/
+
+class Elements;
+class Nodes;
+class Vertices;
+class Loads;
+class Materials;
+class Parameters;
+class FemModel;
+
+class DependentObject: public Object{
+
+	public:
+
+		int name;
+		int type;  /*0: scalar, 1: vertex*/
+		int index;  /*0: scalar, 1: vertex*/
+
+		/*DependentObject constructors, destructors {{{*/
+		DependentObject();
+		DependentObject(int name, int type,int index);
+		~DependentObject();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		void  Echo();
+		void  DeepEcho();
+		int   Id(); 
+		int   ObjectEnum();
+		Object* copy(void);
+		/*}}}*/
+
+		/*DependentObject methods: */
+		int  NumDependents(void);
+		void Responsex(IssmDouble* poutput_value,FemModel* femmodel);
+
+};
+#endif //ifndef _DEPENDENTOBJECT_H_
Index: issm/trunk/src/c/classes/objects/ElementResults/BoolElementResult.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/ElementResults/BoolElementResult.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/ElementResults/BoolElementResult.cpp	(revision 13975)
@@ -58,10 +58,4 @@
 int    BoolElementResult::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION BoolElementResult::MyRank{{{*/
-int    BoolElementResult::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION BoolElementResult::ObjectEnum{{{*/
 int BoolElementResult::ObjectEnum(void){
@@ -116,5 +110,5 @@
 /*FUNCTION BoolElementResult::PatchFill{{{*/
 void BoolElementResult::PatchFill(int row, Patch* patch){
-	
+
 	 /*Here, we fill the result information into the patch object. First, let's remember what is in a row 
 	  * of the patch object: enum_type step time element_id interpolation vertices_ids nodal_values
Index: issm/trunk/src/c/classes/objects/ElementResults/BoolElementResult.h
===================================================================
--- issm/trunk/src/c/classes/objects/ElementResults/BoolElementResult.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/ElementResults/BoolElementResult.h	(revision 13975)
@@ -3,5 +3,4 @@
  *  A boll result object is just derived from a BoolInput object, with additional time and step information.
  */
-
 
 #ifndef _BOOLELEMENTRESULT_H_
@@ -34,5 +33,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/ElementResults/DoubleElementResult.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/ElementResults/DoubleElementResult.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/ElementResults/DoubleElementResult.cpp	(revision 13975)
@@ -58,10 +58,4 @@
 int    DoubleElementResult::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION DoubleElementResult::MyRank{{{*/
-int    DoubleElementResult::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION DoubleElementResult::ObjectEnum{{{*/
 int DoubleElementResult::ObjectEnum(void){
@@ -106,5 +100,5 @@
 /*FUNCTION DoubleElementResult::ProcessUnits{{{*/
 void DoubleElementResult::ProcessUnits(Parameters* parameters){
-	
+
 	this->value=UnitConversion(this->value,IuToExtEnum,this->enum_type);
 
@@ -118,5 +112,5 @@
 /*FUNCTION DoubleElementResult::PatchFill{{{*/
 void DoubleElementResult::PatchFill(int row, Patch* patch){
-	
+
 	 /*Here, we fill the result information into the patch object. First, let's remember what is in a row 
 	  * of the patch object: enum_type step time element_id interpolation vertices_ids nodal_values
Index: issm/trunk/src/c/classes/objects/ElementResults/DoubleElementResult.h
===================================================================
--- issm/trunk/src/c/classes/objects/ElementResults/DoubleElementResult.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/ElementResults/DoubleElementResult.h	(revision 13975)
@@ -3,5 +3,4 @@
  *  A IssmDouble result object is just derived from a DoubleInput object, with additional time and step information.
  */
-
 
 #ifndef _DOUBLEELEMENTRESULT_H_
@@ -34,5 +33,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/ElementResults/PentaP1ElementResult.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/ElementResults/PentaP1ElementResult.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/ElementResults/PentaP1ElementResult.cpp	(revision 13975)
@@ -61,10 +61,4 @@
 int    PentaP1ElementResult::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION PentaP1ElementResult::MyRank{{{*/
-int    PentaP1ElementResult::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION PentaP1ElementResult::ObjectEnum{{{*/
 int PentaP1ElementResult::ObjectEnum(void){
@@ -76,5 +70,5 @@
 /*FUNCTION PentaP1ElementResult::copy{{{*/
 Object* PentaP1ElementResult::copy() {
-	
+
 	return new PentaP1ElementResult(this->enum_type,this->values,this->step,this->time);
 
@@ -117,5 +111,5 @@
 /*FUNCTION PentaP1ElementResult::ProcessUnits{{{*/
 void PentaP1ElementResult::ProcessUnits(Parameters* parameters){
-	
+
 	UnitConversion(this->values,6,IuToExtEnum,this->enum_type);
 
@@ -129,5 +123,5 @@
 /*FUNCTION PentaP1ElementResult::PatchFill{{{*/
 void PentaP1ElementResult::PatchFill(int row, Patch* patch){
-	
+
 	 /*Here, we fill the result information into the patch object. First, let's remember what is in a row 
 	  * of the patch object: enum_type step time element_id interpolation vertices_ids nodal_values
Index: issm/trunk/src/c/classes/objects/ElementResults/PentaP1ElementResult.h
===================================================================
--- issm/trunk/src/c/classes/objects/ElementResults/PentaP1ElementResult.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/ElementResults/PentaP1ElementResult.h	(revision 13975)
@@ -3,5 +3,4 @@
  *  this object is just a PentaP1Input with additional time and step info.
  */
-
 
 #ifndef _PENTAP1ELEMENTRESULT_H_
@@ -33,5 +32,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/ElementResults/TriaP1ElementResult.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/ElementResults/TriaP1ElementResult.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/ElementResults/TriaP1ElementResult.cpp	(revision 13975)
@@ -49,5 +49,5 @@
 /*FUNCTION TriaP1ElementResult::DeepEcho{{{*/
 void TriaP1ElementResult::DeepEcho(void){
-		
+
 	_printLine_("TriaP1ElementResult:");
 	_printLine_("   enum: " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")");
@@ -60,10 +60,4 @@
 int    TriaP1ElementResult::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION TriaP1ElementResult::MyRank{{{*/
-int    TriaP1ElementResult::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION TriaP1ElementResult::ObjectEnum{{{*/
 int TriaP1ElementResult::ObjectEnum(void){
@@ -75,5 +69,5 @@
 /*FUNCTION TriaP1ElementResult::copy{{{*/
 Object* TriaP1ElementResult::copy() {
-	
+
 	return new TriaP1ElementResult(this->enum_type,this->values,this->step,this->time);
 
@@ -105,5 +99,5 @@
 /*FUNCTION TriaP1ElementResult::ProcessUnits{{{*/
 void TriaP1ElementResult::ProcessUnits(Parameters* parameters){
-	
+
 	UnitConversion(this->values,3,IuToExtEnum,this->enum_type);
 
@@ -117,5 +111,5 @@
 /*FUNCTION TriaP1ElementResult::PatchFill{{{*/
 void TriaP1ElementResult::PatchFill(int row, Patch* patch){
-	
+
 	 /*Here, we fill the result information into the patch object. First, let's remember what is in a row 
 	  * of the patch object: enum_type step time element_id interpolation vertices_ids nodal_values
Index: issm/trunk/src/c/classes/objects/ElementResults/TriaP1ElementResult.h
===================================================================
--- issm/trunk/src/c/classes/objects/ElementResults/TriaP1ElementResult.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/ElementResults/TriaP1ElementResult.h	(revision 13975)
@@ -2,5 +2,4 @@
  *  \brief: header file for TriaP1ElementResult object
  */
-
 
 #ifndef _TRIAP1ELEMENTRESULT_H_
@@ -32,5 +31,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/Elements/Element.h
===================================================================
--- issm/trunk/src/c/classes/objects/Elements/Element.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Elements/Element.h	(revision 13975)
@@ -4,5 +4,4 @@
  * It is derived from Element, so DataSets can contain them.
  */ 
-
 
 #ifndef _ELEMENT_H_
@@ -25,9 +24,10 @@
 
 	public: 
-		
+
 		virtual        ~Element(){};
-	
+
 		virtual void   Configure(Elements* elements,Loads* loads,DataSet* nodes,Materials* materials,Parameters* parameters)=0;
 		virtual void   SetCurrentConfiguration(Elements* elements,Loads* loads,DataSet* nodes,Materials* materials,Parameters* parameters)=0;
+		virtual void   SetwiseNodeConnectivity(int* d_nz,int* o_nz,Node* node,bool* flags,int set1_enum,int set2_enum)=0;
 		virtual void   CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>*  Kfs,Vector<IssmDouble>* df)=0;
 		virtual void   CreatePVector(Vector<IssmDouble>* pf)=0;
@@ -35,4 +35,7 @@
 		virtual void   GetSolutionFromInputs(Vector<IssmDouble>* solution)=0;
 		virtual int    GetNodeIndex(Node* node)=0;
+		virtual int    GetNumberOfNodes(void)=0;
+		virtual void   GetNodesSidList(int* sidlist)=0;
+
 		virtual int    Sid()=0;
 		virtual bool   IsFloating()=0; 
@@ -43,5 +46,5 @@
 		virtual void   GetInputListOnVertices(IssmDouble* pvalue,int enumtype,IssmDouble defaultvalue)=0;
 		virtual void   GetInputValue(IssmDouble* pvalue,Node* node,int enumtype)=0;
-		
+
 		virtual IssmDouble SurfaceArea(void)=0;
 		virtual void   InputDepthAverageAtBase(int enum_type,int average_enum_type,int object_enum)=0;
@@ -59,5 +62,5 @@
 		virtual void   ProcessResultsUnits(void)=0;
 		virtual void   RequestedOutput(int output_enum,int step,IssmDouble time)=0;
-		
+
 		virtual int    NodalValue(IssmDouble* pvalue, int index, int natureofdataenum,bool process_units)=0;
 		virtual void   InputScale(int enum_type,IssmDouble scale_factor)=0;
